/*
 * Soubor:  funkce.c
 * Datum:   08.10.2007 11:20
 * Autor:   David Martinek, martinek@fit.vutbr.cz
 * Projekt: funkce
 * Popis:   Demonstrace rznch zpsob vytven funkc a pedvn parametr.
 */

#include <stdio.h>
#include <stdlib.h>

/**
 * Tahle funkce nic nevrac a nem dn parametry.
 * Tohle je hlavika funkce (prototyp). Implementace je nkde dle.
 */
void printHelp(void);

void parametrHodnotou(int cislo)
{
  printf("  Parametr pedan hodnotou: %d\n", cislo);
  cislo += 30;
  printf("  Hodnota modifikovna ve funkci: %d\n", cislo);
}

void parametrOdkazem(int *cislo)
{
  // pi pedvn odkazem je poteba pouvat dereferenn opertor *
  printf("  Parametr pedan odkazem: %d\n", *cislo);
  *cislo += 30;
  printf("  Hodnota modifikovna ve funkci: %d\n", *cislo); 
}

int secti(int a, int b)
{
  return a + b;
}

int main(void)
{
  printHelp();

  printf("Funkce void parametrHodnotou(int cislo)\n");
  printf("  Pedm konstantu:\n");
  parametrHodnotou(10);
  printf("  Te pedm promnnou x = 15:\n");
  int x = 15;
  parametrHodnotou(x);
  printf("  Hodnota promnn x po zavoln funkce: %d\n", x);

  printf("---------------------------------------\n");
  printf("Funkce void parametrOdkazem(int *cislo)\n");
  printf("  Te nelze pedat konstantu (pro asi?)\n");
  printf("  Pedvm promnnou x = 123\n");
  x = 123;
  // pi pedvn parametru je poteba vyrobit z promnn odkaz - pomoc
  // referenho opertoru &
  parametrOdkazem(&x);
  printf("  Hodnota promnn x po zavoln funkce: %d\n", x);

  printf("---------------------------------------\n");
  printf("Funkce int secti(int a, int b)\n");
  printf("  secti(1, 2) = %d\n", secti(1, 2));


  return EXIT_SUCCESS;
}


/**
 * Tahle funkce nic nevrac a nem dn parametry.
 * Tohle je tlo funkce (implementace).
 */

void printHelp(void)
{
  printf("Program pro demonstraci funkc a pedvn parametr funkcm.\n");
}


/* konec souboru funkce.c */
